<?php
namespace GPLSCore\GPLS_PLUGIN_SLI\Utils;

defined( 'ABSPATH' ) || exit();

/**
 * Get List of Countries for Select input.
 *
 * @return array
 */
function get_countries() {
	return array(
		'AF' => __( 'Afghanistan' ),
		'AX' => __( 'Åland Islands' ),
		'AL' => __( 'Albania' ),
		'DZ' => __( 'Algeria' ),
		'AS' => __( 'American Samoa' ),
		'AD' => __( 'Andorra' ),
		'AO' => __( 'Angola' ),
		'AI' => __( 'Anguilla' ),
		'AQ' => __( 'Antarctica' ),
		'AG' => __( 'Antigua and Barbuda' ),
		'AR' => __( 'Argentina' ),
		'AM' => __( 'Armenia' ),
		'AW' => __( 'Aruba' ),
		'AU' => __( 'Australia' ),
		'AT' => __( 'Austria' ),
		'AZ' => __( 'Azerbaijan' ),
		'BS' => __( 'Bahamas' ),
		'BH' => __( 'Bahrain' ),
		'BD' => __( 'Bangladesh' ),
		'BB' => __( 'Barbados' ),
		'BY' => __( 'Belarus' ),
		'BE' => __( 'Belgium' ),
		'PW' => __( 'Belau' ),
		'BZ' => __( 'Belize' ),
		'BJ' => __( 'Benin' ),
		'BM' => __( 'Bermuda' ),
		'BT' => __( 'Bhutan' ),
		'BO' => __( 'Bolivia' ),
		'BQ' => __( 'Bonaire, Saint Eustatius and Saba' ),
		'BA' => __( 'Bosnia and Herzegovina' ),
		'BW' => __( 'Botswana' ),
		'BV' => __( 'Bouvet Island' ),
		'BR' => __( 'Brazil' ),
		'IO' => __( 'British Indian Ocean Territory' ),
		'BN' => __( 'Brunei' ),
		'BG' => __( 'Bulgaria' ),
		'BF' => __( 'Burkina Faso' ),
		'BI' => __( 'Burundi' ),
		'KH' => __( 'Cambodia' ),
		'CM' => __( 'Cameroon' ),
		'CA' => __( 'Canada' ),
		'CV' => __( 'Cape Verde' ),
		'KY' => __( 'Cayman Islands' ),
		'CF' => __( 'Central African Republic' ),
		'TD' => __( 'Chad' ),
		'CL' => __( 'Chile' ),
		'CN' => __( 'China' ),
		'CX' => __( 'Christmas Island' ),
		'CC' => __( 'Cocos (Keeling) Islands' ),
		'CO' => __( 'Colombia' ),
		'KM' => __( 'Comoros' ),
		'CG' => __( 'Congo (Brazzaville)' ),
		'CD' => __( 'Congo (Kinshasa)' ),
		'CK' => __( 'Cook Islands' ),
		'CR' => __( 'Costa Rica' ),
		'HR' => __( 'Croatia' ),
		'CU' => __( 'Cuba' ),
		'CW' => __( 'Cura&ccedil;ao' ),
		'CY' => __( 'Cyprus' ),
		'CZ' => __( 'Czech Republic' ),
		'DK' => __( 'Denmark' ),
		'DJ' => __( 'Djibouti' ),
		'DM' => __( 'Dominica' ),
		'DO' => __( 'Dominican Republic' ),
		'EC' => __( 'Ecuador' ),
		'EG' => __( 'Egypt' ),
		'SV' => __( 'El Salvador' ),
		'GQ' => __( 'Equatorial Guinea' ),
		'ER' => __( 'Eritrea' ),
		'EE' => __( 'Estonia' ),
		'ET' => __( 'Ethiopia' ),
		'FK' => __( 'Falkland Islands' ),
		'FO' => __( 'Faroe Islands' ),
		'FJ' => __( 'Fiji' ),
		'FI' => __( 'Finland' ),
		'FR' => __( 'France' ),
		'GF' => __( 'French Guiana' ),
		'PF' => __( 'French Polynesia' ),
		'TF' => __( 'French Southern Territories' ),
		'GA' => __( 'Gabon' ),
		'GM' => __( 'Gambia' ),
		'GE' => __( 'Georgia' ),
		'DE' => __( 'Germany' ),
		'GH' => __( 'Ghana' ),
		'GI' => __( 'Gibraltar' ),
		'GR' => __( 'Greece' ),
		'GL' => __( 'Greenland' ),
		'GD' => __( 'Grenada' ),
		'GP' => __( 'Guadeloupe' ),
		'GU' => __( 'Guam' ),
		'GT' => __( 'Guatemala' ),
		'GG' => __( 'Guernsey' ),
		'GN' => __( 'Guinea' ),
		'GW' => __( 'Guinea-Bissau' ),
		'GY' => __( 'Guyana' ),
		'HT' => __( 'Haiti' ),
		'HM' => __( 'Heard Island and McDonald Islands' ),
		'HN' => __( 'Honduras' ),
		'HK' => __( 'Hong Kong' ),
		'HU' => __( 'Hungary' ),
		'IS' => __( 'Iceland' ),
		'IN' => __( 'India' ),
		'ID' => __( 'Indonesia' ),
		'IR' => __( 'Iran' ),
		'IQ' => __( 'Iraq' ),
		'IE' => __( 'Ireland' ),
		'IM' => __( 'Isle of Man' ),
		'IL' => __( 'Israel' ),
		'IT' => __( 'Italy' ),
		'CI' => __( 'Ivory Coast' ),
		'JM' => __( 'Jamaica' ),
		'JP' => __( 'Japan' ),
		'JE' => __( 'Jersey' ),
		'JO' => __( 'Jordan' ),
		'KZ' => __( 'Kazakhstan' ),
		'KE' => __( 'Kenya' ),
		'KI' => __( 'Kiribati' ),
		'KW' => __( 'Kuwait' ),
		'KG' => __( 'Kyrgyzstan' ),
		'LA' => __( 'Laos' ),
		'LV' => __( 'Latvia' ),
		'LB' => __( 'Lebanon' ),
		'LS' => __( 'Lesotho' ),
		'LR' => __( 'Liberia' ),
		'LY' => __( 'Libya' ),
		'LI' => __( 'Liechtenstein' ),
		'LT' => __( 'Lithuania' ),
		'LU' => __( 'Luxembourg' ),
		'MO' => __( 'Macao' ),
		'MK' => __( 'North Macedonia' ),
		'MG' => __( 'Madagascar' ),
		'MW' => __( 'Malawi' ),
		'MY' => __( 'Malaysia' ),
		'MV' => __( 'Maldives' ),
		'ML' => __( 'Mali' ),
		'MT' => __( 'Malta' ),
		'MH' => __( 'Marshall Islands' ),
		'MQ' => __( 'Martinique' ),
		'MR' => __( 'Mauritania' ),
		'MU' => __( 'Mauritius' ),
		'YT' => __( 'Mayotte' ),
		'MX' => __( 'Mexico' ),
		'FM' => __( 'Micronesia' ),
		'MD' => __( 'Moldova' ),
		'MC' => __( 'Monaco' ),
		'MN' => __( 'Mongolia' ),
		'ME' => __( 'Montenegro' ),
		'MS' => __( 'Montserrat' ),
		'MA' => __( 'Morocco' ),
		'MZ' => __( 'Mozambique' ),
		'MM' => __( 'Myanmar' ),
		'NA' => __( 'Namibia' ),
		'NR' => __( 'Nauru' ),
		'NP' => __( 'Nepal' ),
		'NL' => __( 'Netherlands' ),
		'NC' => __( 'New Caledonia' ),
		'NZ' => __( 'New Zealand' ),
		'NI' => __( 'Nicaragua' ),
		'NE' => __( 'Niger' ),
		'NG' => __( 'Nigeria' ),
		'NU' => __( 'Niue' ),
		'NF' => __( 'Norfolk Island' ),
		'MP' => __( 'Northern Mariana Islands' ),
		'KP' => __( 'North Korea' ),
		'NO' => __( 'Norway' ),
		'OM' => __( 'Oman' ),
		'PK' => __( 'Pakistan' ),
		'PS' => __( 'Palestinian Territory' ),
		'PA' => __( 'Panama' ),
		'PG' => __( 'Papua New Guinea' ),
		'PY' => __( 'Paraguay' ),
		'PE' => __( 'Peru' ),
		'PH' => __( 'Philippines' ),
		'PN' => __( 'Pitcairn' ),
		'PL' => __( 'Poland' ),
		'PT' => __( 'Portugal' ),
		'PR' => __( 'Puerto Rico' ),
		'QA' => __( 'Qatar' ),
		'RE' => __( 'Reunion' ),
		'RO' => __( 'Romania' ),
		'RU' => __( 'Russia' ),
		'RW' => __( 'Rwanda' ),
		'BL' => __( 'Saint Barth&eacute;lemy' ),
		'SH' => __( 'Saint Helena' ),
		'KN' => __( 'Saint Kitts and Nevis' ),
		'LC' => __( 'Saint Lucia' ),
		'MF' => __( 'Saint Martin (French part)' ),
		'SX' => __( 'Saint Martin (Dutch part)' ),
		'PM' => __( 'Saint Pierre and Miquelon' ),
		'VC' => __( 'Saint Vincent and the Grenadines' ),
		'SM' => __( 'San Marino' ),
		'ST' => __( 'S&atilde;o Tom&eacute; and Pr&iacute;ncipe' ),
		'SA' => __( 'Saudi Arabia' ),
		'SN' => __( 'Senegal' ),
		'RS' => __( 'Serbia' ),
		'SC' => __( 'Seychelles' ),
		'SL' => __( 'Sierra Leone' ),
		'SG' => __( 'Singapore' ),
		'SK' => __( 'Slovakia' ),
		'SI' => __( 'Slovenia' ),
		'SB' => __( 'Solomon Islands' ),
		'SO' => __( 'Somalia' ),
		'ZA' => __( 'South Africa' ),
		'GS' => __( 'South Georgia/Sandwich Islands' ),
		'KR' => __( 'South Korea' ),
		'SS' => __( 'South Sudan' ),
		'ES' => __( 'Spain' ),
		'LK' => __( 'Sri Lanka' ),
		'SD' => __( 'Sudan' ),
		'SR' => __( 'Suriname' ),
		'SJ' => __( 'Svalbard and Jan Mayen' ),
		'SZ' => __( 'Swaziland' ),
		'SE' => __( 'Sweden' ),
		'CH' => __( 'Switzerland' ),
		'SY' => __( 'Syria' ),
		'TW' => __( 'Taiwan' ),
		'TJ' => __( 'Tajikistan' ),
		'TZ' => __( 'Tanzania' ),
		'TH' => __( 'Thailand' ),
		'TL' => __( 'Timor-Leste' ),
		'TG' => __( 'Togo' ),
		'TK' => __( 'Tokelau' ),
		'TO' => __( 'Tonga' ),
		'TT' => __( 'Trinidad and Tobago' ),
		'TN' => __( 'Tunisia' ),
		'TR' => __( 'Turkey' ),
		'TM' => __( 'Turkmenistan' ),
		'TC' => __( 'Turks and Caicos Islands' ),
		'TV' => __( 'Tuvalu' ),
		'UG' => __( 'Uganda' ),
		'UA' => __( 'Ukraine' ),
		'AE' => __( 'United Arab Emirates' ),
		'GB' => __( 'United Kingdom (UK)' ),
		'US' => __( 'United States (US)' ),
		'UM' => __( 'United States (US) Minor Outlying Islands' ),
		'UY' => __( 'Uruguay' ),
		'UZ' => __( 'Uzbekistan' ),
		'VU' => __( 'Vanuatu' ),
		'VA' => __( 'Vatican' ),
		'VE' => __( 'Venezuela' ),
		'VN' => __( 'Vietnam' ),
		'VG' => __( 'Virgin Islands (British)' ),
		'VI' => __( 'Virgin Islands (US)' ),
		'WF' => __( 'Wallis and Futuna' ),
		'EH' => __( 'Western Sahara' ),
		'WS' => __( 'Samoa' ),
		'YE' => __( 'Yemen' ),
		'ZM' => __( 'Zambia' ),
		'ZW' => __( 'Zimbabwe' ),
	);
}

/**
 * Get Timezones List.
 *
 * @return array
 */
function get_timezones() {

	return array(
		'Pacific/Midway'                 => '(GMT-11:00) Midway Island, Samoa ',
		'Pacific/Pago_Pago'              => '(GMT-11:00) Pago Pago ',
		'Pacific/Honolulu'               => '(GMT-10:00) Hawaii ',
		'America/Anchorage'              => '(GMT-8:00) Alaska ',
		'America/Juneau'                 => '(GMT-8:00) Juneau ',
		'America/Vancouver'              => '(GMT-7:00) Vancouver ',
		'America/Los_Angeles'            => '(GMT-7:00) Pacific Time (US and Canada) ',
		'America/Tijuana'                => '(GMT-7:00) Tijuana ',
		'America/Phoenix'                => '(GMT-7:00) Arizona ',
		'America/Mazatlan'               => '(GMT-7:00) Mazatlan ',
		'America/Chihuahua'              => '(GMT-7:00) Chihuahua ',
		'America/Edmonton'               => '(GMT-6:00) Edmonton ',
		'America/Denver'                 => '(GMT-6:00) Mountain Time (US and Canada) ',
		'America/Regina'                 => '(GMT-6:00) Saskatchewan ',
		'America/Guatemala'              => '(GMT-6:00) Guatemala ',
		'America/Mexico_City'            => '(GMT-6:00) Mexico City ',
		'America/El_Salvador'            => '(GMT-6:00) El Salvador ',
		'America/Managua'                => '(GMT-6:00) Managua ',
		'America/Costa_Rica'             => '(GMT-6:00) Costa Rica ',
		'America/Tegucigalpa'            => '(GMT-6:00) Tegucigalpa ',
		'America/Monterrey'              => '(GMT-6:00) Monterrey ',
		'America/Winnipeg'               => '(GMT-5:00) Winnipeg ',
		'America/Chicago'                => '(GMT-5:00) Central Time (US and Canada) ',
		'America/Panama'                 => '(GMT-5:00) Panama ',
		'America/Bogota'                 => '(GMT-5:00) Bogota ',
		'America/Lima'                   => '(GMT-5:00) Lima ',
		'America/Montreal'               => '(GMT-4:00) Montreal ',
		'America/New_York'               => '(GMT-4:00) Eastern Time (US and Canada) ',
		'America/Indianapolis'           => '(GMT-4:00) Indiana (East) ',
		'America/Puerto_Rico'            => '(GMT-4:00) Puerto Rico ',
		'America/Caracas'                => '(GMT-4:00) Caracas ',
		'America/La_Paz'                 => '(GMT-4:00) La Paz ',
		'America/Guyana'                 => '(GMT-4:00) Guyana ',
		'America/Halifax'                => '(GMT-3:00) Halifax ',
		'America/Santiago'               => '(GMT-3:00) Santiago ',
		'America/Montevideo'             => '(GMT-3:00) Montevideo ',
		'America/Araguaina'              => '(GMT-3:00) Recife ',
		'America/Argentina/Buenos_Aires' => '(GMT-3:00) Buenos Aires ',
		'America/Godthab'                => '(GMT-3:00) Greenland ',
		'America/Sao_Paulo'              => '(GMT-3:00) Sao Paulo ',
		'Canada/Atlantic'                => '(GMT-3:00) Atlantic Time (Canada) ',
		'America/St_Johns'               => '(GMT-2:30) Newfoundland and Labrador ',
		'Atlantic/Cape_Verde'            => '(GMT-1:00) Cape Verde Islands ',
		'Atlantic/Azores'                => '(GMT+0:00) Azores ',
		'UTC'                            => '(GMT+0:00) Universal Time UTC ',
		'Etc/Greenwich'                  => '(GMT+0:00) Greenwich Mean Time ',
		'Atlantic/Reykjavik'             => '(GMT+0:00) Reykjavik ',
		'Europe/Dublin'                  => '(GMT+0:00) Dublin ',
		'Europe/London'                  => '(GMT+0:00) London ',
		'Europe/Lisbon'                  => '(GMT+0:00) Lisbon ',
		'Africa/Nouakchott'              => '(GMT+0:00) Nouakchott ',
		'Europe/Belgrade'                => '(GMT+1:00) Belgrade, Bratislava, Ljubljana ',
		'CET'                            => '(GMT+1:00) Sarajevo, Skopje, Zagreb ',
		'Africa/Casablanca'              => '(GMT+1:00) Casablanca ',
		'Europe/Oslo'                    => '(GMT+1:00) Oslo ',
		'Europe/Copenhagen'              => '(GMT+1:00) Copenhagen ',
		'Europe/Brussels'                => '(GMT+1:00) Brussels ',
		'Europe/Berlin'                  => '(GMT+1:00) Amsterdam, Berlin, Rome, Stockholm, Vienna ',
		'Europe/Amsterdam'               => '(GMT+1:00) Amsterdam ',
		'Europe/Rome'                    => '(GMT+1:00) Rome ',
		'Europe/Stockholm'               => '(GMT+1:00) Stockholm ',
		'Europe/Vienna'                  => '(GMT+1:00) Vienna ',
		'Europe/Luxembourg'              => '(GMT+1:00) Luxembourg ',
		'Europe/Paris'                   => '(GMT+1:00) Paris ',
		'Europe/Zurich'                  => '(GMT+1:00) Zurich ',
		'Europe/Madrid'                  => '(GMT+1:00) Madrid ',
		'Africa/Bangui'                  => '(GMT+1:00) West Central Africa ',
		'Africa/Algiers'                 => '(GMT+1:00) Algiers ',
		'Africa/Tunis'                   => '(GMT+1:00) Tunis ',
		'Europe/Warsaw'                  => '(GMT+1:00) Warsaw ',
		'Europe/Prague'                  => '(GMT+1:00) Prague Bratislava ',
		'Europe/Budapest'                => '(GMT+1:00) Budapest ',
		'Europe/Helsinki'                => '(GMT+2:00) Helsinki ',
		'Africa/Harare'                  => '(GMT+2:00) Harare, Pretoria ',
		'Europe/Sofia'                   => '(GMT+2:00) Sofia ',
		'Europe/Athens'                  => '(GMT+2:00) Athens ',
		'Europe/Bucharest'               => '(GMT+2:00) Bucharest ',
		'Asia/Nicosia'                   => '(GMT+2:00) Nicosia ',
		'Asia/Beirut'                    => '(GMT+2:00) Beirut ',
		'Asia/Jerusalem'                 => '(GMT+2:00) Jerusalem ',
		'Africa/Tripoli'                 => '(GMT+2:00) Tripoli ',
		'Africa/Cairo'                   => '(GMT+2:00) Cairo ',
		'Africa/Johannesburg'            => '(GMT+2:00) Johannesburg ',
		'Africa/Khartoum'                => '(GMT+2:00) Khartoum ',
		'Europe/Kiev'                    => '(GMT+2:00) Kiev ',
		'Africa/Nairobi'                 => '(GMT+3:00) Nairobi ',
		'Europe/Istanbul'                => '(GMT+3:00) Istanbul ',
		'Asia/Damascus'                  => '(GMT+3:00) Damascus ',
		'Asia/Amman'                     => '(GMT+3:00) Amman ',
		'Europe/Moscow'                  => '(GMT+3:00) Moscow ',
		'Asia/Baghdad'                   => '(GMT+3:00) Baghdad ',
		'Asia/Kuwait'                    => '(GMT+3:00) Kuwait ',
		'Asia/Riyadh'                    => '(GMT+3:00) Riyadh ',
		'Asia/Bahrain'                   => '(GMT+3:00) Bahrain ',
		'Asia/Qatar'                     => '(GMT+3:00) Qatar ',
		'Asia/Aden'                      => '(GMT+3:00) Aden ',
		'Africa/Djibouti'                => '(GMT+3:00) Djibouti ',
		'Africa/Mogadishu'               => '(GMT+3:00) Mogadishu ',
		'Europe/Minsk'                   => '(GMT+3:00) Minsk ',
		'Asia/Tehran'                    => '(GMT+3:30) Tehran ',
		'Asia/Dubai'                     => '(GMT+4:00) Dubai ',
		'Asia/Muscat'                    => '(GMT+4:00) Muscat ',
		'Asia/Baku'                      => '(GMT+4:00) Baku, Tbilisi, Yerevan ',
		'Asia/Kabul'                     => '(GMT+4:30) Kabul ',
		'Asia/Yekaterinburg'             => '(GMT+5:00) Yekaterinburg ',
		'Asia/Tashkent'                  => '(GMT+5:00) Islamabad, Karachi, Tashkent ',
		'Asia/Calcutta'                  => '(GMT+5:30) India ',
		'Asia/Kolkata'                   => '(GMT+5:30) Mumbai, Kolkata, New Delhi ',
		'Asia/Kathmandu'                 => '(GMT+5:45) Kathmandu ',
		'Asia/Almaty'                    => '(GMT+6:00) Almaty ',
		'Asia/Dacca'                     => '(GMT+6:00) Dacca ',
		'Asia/Dhaka'                     => '(GMT+6:00) Astana, Dhaka ',
		'Asia/Rangoon'                   => '(GMT+6:30) Rangoon ',
		'Asia/Novosibirsk'               => '(GMT+7:00) Novosibirsk ',
		'Asia/Krasnoyarsk'               => '(GMT+7:00) Krasnoyarsk ',
		'Asia/Bangkok'                   => '(GMT+7:00) Bangkok ',
		'Asia/Saigon'                    => '(GMT+7:00) Vietnam ',
		'Asia/Jakarta'                   => '(GMT+7:00) Jakarta ',
		'Asia/Irkutsk'                   => '(GMT+8:00) Irkutsk ',
		'Asia/Shanghai'                  => '(GMT+8:00) Beijing ',
		'Asia/Hong_Kong'                 => '(GMT+8:00) Hong Kong SAR ',
		'Asia/Taipei'                    => '(GMT+8:00) Taipei ',
		'Asia/Kuala_Lumpur'              => '(GMT+8:00) Kuala Lumpur ',
		'Asia/Singapore'                 => '(GMT+8:00) Singapore ',
		'Australia/Perth'                => '(GMT+8:00) Perth ',
		'Asia/Yakutsk'                   => '(GMT+9:00) Yakutsk ',
		'Asia/Seoul'                     => '(GMT+9:00) Seoul ',
		'Asia/Tokyo'                     => '(GMT+9:00) Osaka, Sapporo, Tokyo ',
		'Australia/Darwin'               => '(GMT+9:30) Darwin ',
		'Asia/Vladivostok'               => '(GMT+10:00) Vladivostok ',
		'Pacific/Port_Moresby'           => '(GMT+10:00) Guam, Port Moresby ',
		'Australia/Brisbane'             => '(GMT+10:00) Brisbane ',
		'Australia/Adelaide'             => '(GMT+10:30) Adelaide ',
		'Australia/Sydney'               => '(GMT+11:00) Canberra, Melbourne, Sydney ',
		'Australia/Hobart'               => '(GMT+11:00) Hobart ',
		'Asia/Magadan'                   => '(GMT+11:00) Magadan ',
		'SST'                            => '(GMT+11:00) Solomon Islands ',
		'Pacific/Noumea'                 => '(GMT+11:00) New Caledonia ',
		'Asia/Kamchatka'                 => '(GMT+12:00) Kamchatka ',
		'Pacific/Fiji'                   => '(GMT+12:00) Fiji Islands, Marshall Islands ',
		'Pacific/Auckland'               => '(GMT+13:00) Auckland, Wellington ',
		'Pacific/Apia'                   => '(GMT+14:00) Independent State of Samoa ',
	);
}


/**
 * Get Timezone Title.
 *
 * @param string $timezone
 * @return string
 */
function get_timezone_title( $timezone ) {
	$timezones = get_timezones();
	if ( ! empty( $timezones[ $timezone ] ) ) {
		return $timezones[ $timezone ];
	} else {
		return '';
	}
}
